using System.Web.Mvc;
using CDaysDemo.Models;
using Microsoft.Practices.Unity;
using Unity.Mvc3;

namespace CDaysDemo
{
    public static class Bootstrapper
    {
        public static void Initialise()
        {
            var container = BuildUnityContainer();

            DependencyResolver.SetResolver(new UnityDependencyResolver(container));
        }

        private static IUnityContainer BuildUnityContainer()
        {
            var container = new UnityContainer();

            container.RegisterType<IRepository<Person>, PersonRepository>();

            return container;
        }
    }
}