﻿using System.Linq;
using System.Web.Mvc;
using CDaysDemo.Models;

namespace CDaysDemo.Controllers
{
    public class PeopleController : Controller
    {
        private IRepository<Person> _repository;

        //public PeopleController() : this(new PersonRepository())
        //{ }

        public PeopleController(IRepository<Person> repository)
        {
            _repository = repository;
        }

        public ActionResult Index()
        {
            return View(_repository.GetAll().OrderBy(x => x.Name).ToList());
        }

        protected override void Dispose(bool disposing)
        {
            if (_repository != null)
                _repository.Dispose();

            base.Dispose(disposing);
        }

        public ActionResult Edit(int id)
        {
            var person = _repository.GetById(id);

            return this.View(new PersonViewModel(person));
        }

        [HttpPost]
        public ActionResult Edit(int id, Person person)
        {
            if (ModelState.IsValid)
            {
                _repository.Update(person);
                _repository.SaveChanges();

                return this.RedirectToAction("Index");
            }

            return this.View(new PersonViewModel(person));
        }
    }
}
