﻿using System;
using System.Linq;

namespace CDaysDemo.Models
{
    public interface IRepository<T> : IDisposable
    {
        IQueryable<Person> GetAll();

        Person GetById(int id);

        void Add(Person entity);

        void Update(Person person);

        void RemoveById(int id);

        void SaveChanges();
    }
}