﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace CDaysDemo.Models
{
    public class PersonRepository : IRepository<Person>, IDisposable
    {
        private static List<Person> _people = new List<Person>()
        {
            new Person() { Id = 1, Name = "Marco", Email = "marco@cdays13.net" },
            new Person() { Id = 2, Name = "Cristian", Email = "cristian@cdays13.net" },
            new Person() { Id = 3, Name = "Carlo", Email = "carlo@cdays13.net" },
            new Person() { Id = 4, Name = "Franco", Email = "franco@cdays13.net" }
        };

        public IQueryable<Person> GetAll()
        {
            return _people.AsQueryable();
        }

        public Person GetById(int id)
        {
            return _people.Single(x => x.Id == id);
        }

        public void Add(Person entity)
        {
            entity.Id = _people.Max(x => x.Id) + 1;
            _people.Add(entity);
        }

        public void Update(Person entity)
        {
            var old = this.GetById(entity.Id);

            _people.Remove(old);

            _people.Add(entity);
        }

        public void RemoveById(int id)
        {
            var person = _people.Single(x => x.Id == id);
            _people.Remove(person);
        }

        public void SaveChanges()
        {
            // nothing here
        }

        public void Dispose()
        {
            // nothing here
        }
    }
}