﻿using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;

namespace CDaysDemo.Models
{
    public class PersonViewModel
    {
        public Person Person { get; set; }

        #region Roles
        public List<string> AvailableRoles { get; set; }

        public IEnumerable<SelectListItem> AvailableRolesItems
        {
            get
            {
                return this.AvailableRoles
                    .Select(x => new SelectListItem() { Text = x, Value = x });
            }
        }

        public IEnumerable<SelectListItem> UserRolesItems
        {
            get
            {
                if (this.Person == null || this.Person.Roles == null)
                    return new SelectListItem[0];

                return this.Person.Roles
                    .Select(x => new SelectListItem() { Text = x, Value = x });
            }
        }

        public PersonViewModel()
        {
            this.AvailableRoles = new List<string>() 
            {
                "Administrator",
                "AreaManager",
                "SuperUser",
                "User"
            };
        }

        public PersonViewModel(Person person)
            : this()
        {
            this.Person = person;
            if (this.Person.Roles != null)
            {
                this.AvailableRoles = this.AvailableRoles.Except(person.Roles).ToList();
            }
        }
        #endregion
    }
}