﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using System.Web.Http.OData;
using WebApiDemo.Models;
using System.Web.Http.Tracing;

namespace WebApiDemo.Controllers
{
    public class PeopleController : EntitySetController<Person, int>
    {
        private CDays13DemoEntities _context;

        public PeopleController()
        {
            _context = new CDays13DemoEntities();
            _context.Configuration.ProxyCreationEnabled = false;
        }

        public override IQueryable<Person> Get()
        {
            this.Configuration.Services.GetTraceWriter().Info(this.Request, "Custom", "Sample text");

            return _context.People.OrderBy(x => x.Name);
        }

        protected override int GetKey(Person entity)
        {
            if (entity == null)
                throw new ArgumentNullException("entity");

            return entity.Id;
        }

        protected override Person GetEntityByKey(int key)
        {
            return _context.People.SingleOrDefault(x => x.Id == key);
        }

        protected override Person CreateEntity(Person entity)
        {
            _context.People.Add(entity);

            _context.SaveChanges();

            return entity;
        }

        protected override Person UpdateEntity(int key, Person update)
        {
            var original = _context.People.Single(x => x.Id == key);
            original.Name = update.Name;
            original.BirthDate = update.BirthDate;

            _context.SaveChanges();

            return original;
        }

        public override void Delete(int key)
        {
            var original = _context.People.Single(x => x.Id == key);

            _context.People.Remove(original);

            _context.SaveChanges();
        }

        protected override void Dispose(bool disposing)
        {
            _context.Dispose();
            base.Dispose(disposing);
        }
    }


    //public class PeopleController : ApiController
    //{
    //    private ProveVarieDbEntities _context;

    //    public PeopleController()
    //    {
    //        _context = new ProveVarieDbEntities();
    //        _context.Configuration.ProxyCreationEnabled = false;
    //    }

    //    //[Queryable(MaxSkip = 2)]
    //    public IQueryable<Person> GetAll()
    //    {

    //        return _context.People.OrderBy(x => x.Name);
    //    }

    //    protected override void Dispose(bool disposing)
    //    {
    //        if (_context != null)
    //            _context.Dispose();

    //        base.Dispose(disposing);
    //    }
    //}
}
