﻿using System;
using System.Collections.Concurrent;
using System.Net.Http;
using System.Web.Http.Tracing;

namespace WebApiDemo.Tracing
{
    public class MemoryTracerWriter : ITraceWriter
    {
        public ConcurrentBag<TraceRecord> Traces = new ConcurrentBag<TraceRecord>();

        public void Trace(HttpRequestMessage request, string category, TraceLevel level, Action<TraceRecord> traceAction)
        {
            var record = new TraceRecord(request, category, level);
            traceAction(record);

            this.Traces.Add(record);
        }
    }
}